var HashSet = function(){this.init.apply(this, arguments);};
exports.HashSet = HashSet;

HashSet.prototype = new Array();
HashSet.prototype.constructor = HashSet;
HashSet.parentclass = Array.prototype;

HashSet.prototype.init = function() {

	this.entryItems = new Hash();

	var _present = {};

	/** @ignore */
	this.__dummy__ = function() {

		return _present;
	};
};

/**
* Returns whether this HashSet is equal to the specified HashSet.
* @param {Object} _object
* @return {Boolean}
*/
HashSet.prototype.equals = function(_object) {

	if (this === _object) {

		return true;
	}
	if(this.constructor != _object.constructor) {

		return false;
	}

	// compare lengths
	if(this.size() != _object.size()){ return false; }

	return this.containsAll(_object);
};

// enumerable methods
/**
* Iterate over the HashSet of elements.
* @param {Function} _block The function to execute for every element in the HashSet.
*/
HashSet.prototype.iterator = function(_block) {

	var keys = this.entryList().keys();
	var size = keys.size();
	for(var i=0;i<size;i++) {

		_block(keys.get(i));
	}
};

// querying methods
/**
* Returns true if this HashSet contains the specified element.
* @return {Boolean}
*/
HashSet.prototype.contains = function(_object) {

	return this.entryItems.containsKey(_object);
};

/**
* Returns true if this HashSet contains no elements.
* @return {Boolean}
*/
HashSet.prototype.isEmpty = function() {

	return this.entryItems.isEmpty();
};

/**
* Returns the number of elements in this HashSet.
* @return {Number}
*/
HashSet.prototype.size = function() {

	return this.entryItems.size();
};

// mutating methods
/**
* Adds the specified element to this HashSet if it is not already present.
* @param {Object} _object
* @return {Boolean}
*/
HashSet.prototype.add = function(_object) {

	return (this.entryItems.put(_object, this.__dummy__()) == null);
};

/**
* Removes the specified element from this HashSet if it is present.
* @param {Object} _object
* @return {Bolean}
*/
HashSet.prototype.remove = function(_object) {

	return (this.entryItems.remove(_object) == this.__dummy__());
};

/**
* Removes all of the elements from this HashSet.
*/
HashSet.prototype.clear = function() {

	this.entryItems.clear();
};
