var TestCase = require("bn-unit").TestCase;

// setup test case
var ArrayTest = function(){this.init.apply(this, arguments);};
exports.ArrayTest = ArrayTest;

ArrayTest.prototype = new TestCase();
ArrayTest.prototype.constructor = ArrayTest;
ArrayTest.parentclass = TestCase.prototype;
ArrayTest.prototype.init = function() {}
ArrayTest.prototype.setUp = function(){

	ArrayTest.parentclass.setUp.apply(this, []);

	this.nums1 = [1, 2, 3, 4, 5];
	this.nums2 = [6, 7, 8, 9, 10];
	this.nums3 = [1, 2, 3, 4, 5];

	this.strings1 = ["one", "two", "three", "four", "five"];
	this.strings2 = ["six", "seven", "eight", "nine", "ten"];
	this.strings3 = ["one", "two", "three", "four", "five"];

	var equalsFunction = function(_object) {

		if(this === _object) {

			return true;
		}

		return this.name == _object.name;
	};

	var talkFunction = function(_word) {

		return _word +" "+this.name;
	};

	this.objects = [];
	this.objects.push({name:"One",id:1,toString:function(){return "One: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects.push({name:"Two",id:2,toString:function(){return "Two: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects.push({name:"Three",id:3,toString:function(){return "Three: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects.push({name:"Four",id:4,toString:function(){return "Four: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects.push({name:"Five",id:5,toString:function(){return "Five: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects.push({name:"Six",id:6,toString:function(){return "Six: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects.push({name:"Seven",id:7,toString:function(){return "Seven: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects.push({name:"Eight",id:8,toString:function(){return "Eight: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects.push({name:"Nine",id:9,toString:function(){return "Nine: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects.push({name:"Ten",id:10,toString:function(){return "Ten: "+this.id;},equals:equalsFunction,talk:talkFunction});

	this.objects1 = [];
	this.objects1.push({name:"One",id:1,toString:function(){return "One: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects1.push({name:"Two",id:2,toString:function(){return "Two: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects1.push({name:"Three",id:3,toString:function(){return "Three: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects1.push({name:"Four",id:4,toString:function(){return "Four: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects1.push({name:"Five",id:5,toString:function(){return "Five: "+this.id;},equals:equalsFunction,talk:talkFunction});

	this.objects2 = [];
	this.objects2.push({name:"Six",id:6,toString:function(){return "Six: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects2.push({name:"Seven",id:7,toString:function(){return "Seven: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects2.push({name:"Eight",id:8,toString:function(){return "Eight: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects2.push({name:"Nine",id:9,toString:function(){return "Nine: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects2.push({name:"Ten",id:10,toString:function(){return "Ten: "+this.id;},equals:equalsFunction,talk:talkFunction});

	this.objects3 = [];
	this.objects3.push({name:"One",id:1,toString:function(){return "One: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects3.push({name:"Two",id:2,toString:function(){return "Two: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects3.push({name:"Three",id:3,toString:function(){return "Three: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects3.push({name:"Four",id:4,toString:function(){return "Four: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.objects3.push({name:"Five",id:5,toString:function(){return "Five: "+this.id;},equals:equalsFunction,talk:talkFunction});
};
ArrayTest.prototype.tearDown = function() {

	ArrayTest.parentclass.tearDown.apply(this, []);

	this.nums1 = null;
	this.nums2 = null;
	this.nums3 = null;

	this.strings1 = null;
	this.strings2 = null;
	this.strings3 = null;

	this.objects = null;
	this.objects1 = null;
	this.objects2 = null;
	this.objects3 = null;
};
ArrayTest.getName = function() {

	return "Array";
};

// add tests

ArrayTest.prototype.testEquals = function() {

	var newList = [].concat(this.objects);

	this.assertTrue(this.objects.equals(newList));

	var hold = newList.get(2);
	newList.set(2, newList.get(3));
	this.assertFalse(this.objects.equals(newList));

	newList.set(2, hold);
	this.assertTrue(this.objects.equals(newList));
	this.assertTrue(this.objects.size() == newList.size());

	newList.removeAt(3);
	this.assertFalse(this.objects.size() == newList.size());
	this.assertFalse(this.objects.equals(newList));
	this.assertFalse(this.objects.equals({}));
};

ArrayTest.prototype.testDotEqualsTrue = function() {

	this.assertTrue(this.nums1.equals(this.nums3));
	this.assertTrue(this.strings1.equals(this.strings3));
	this.assertTrue(this.objects1.equals(this.objects3));
};

ArrayTest.prototype.testDotEqualsFalse = function() {

	this.assertFalse(this.nums1.equals(this.nums2));
	this.assertFalse(this.strings1.equals(this.strings2));
	this.assertFalse(this.objects1.equals(this.objects2));
};

ArrayTest.prototype.testToString = function() {

	this.assertTrue(!"".equals(this.objects.toString()));
};

// enumerable tests

ArrayTest.prototype.testEach = function() {

	var me = this;
	var counter = 0;
	this.objects.each(function(_value, _index) {

		if(counter == 0){me.assertTrue(_value.name == "One");}

		if(counter == 9){me.assertTrue(_value.name == "Ten");}

		counter++;
	});

	this.assertTrue(counter == 10);
};

ArrayTest.prototype.testEachBreak = function() {

	var me = this;
	var result = null;
	var counter = 0;
	this.objects.each(function(_value, _index) {

		if(_value.name == "Seven") {

			result = _value;
			counter = _index;
			me.objects.$break();
		}
	});

	this.assertTrue(result.name == "Seven");
	this.assertTrue(counter == 6);
};

ArrayTest.prototype.testEachContinue = function() {

	var me = this;
	var result = null;
	var counter = 0;
	var counter2 = 0;
	var counter3 = 0;
	this.objects.each(function(_value, _index) {

		counter3 = _index;

		if(_value.name != "Seven") {

			me.objects.$continue();
		}

		result = _value;
		counter = _index;
		counter2++;
	});

	this.assertTrue(result.name == "Seven");
	this.assertTrue(counter == 6);
	this.assertTrue(counter2 == 1);
	this.assertTrue(counter3 == 9);
};

ArrayTest.prototype.testAll = function() {

	var result = this.objects.all(function(_value, _index) {
	
		return _value.id >= 1 && _value.id <= 10;
	});

	this.assertTrue(result);

	var result = this.objects.all(function(_value, _index) {

		return _value.id >= 1 && _value.id <= 9;
	});

	this.assertFalse(result);
};

ArrayTest.prototype.testAny = function() {

	var result = this.objects.any(function(_value, _index) {

		return _value.id == 5;
	});

	this.assertTrue(result);

	var result = this.objects.any(function(_value, _index) {

		return _value.id == 11;
	});

	this.assertFalse(result);
};

ArrayTest.prototype.testCollect = function() {

	var items = this.objects.collect(function(_value, _index) {

		return _value.name;
	});
	this.assertTrue(items[0] == "One");
	this.assertTrue(items[1] == "Two");
	this.assertTrue(items[2] == "Three");
	this.assertTrue(items[3] == "Four");
	this.assertTrue(items[4] == "Five");
	this.assertTrue(items[5] == "Six");
	this.assertTrue(items[6] == "Seven");
	this.assertTrue(items[7] == "Eight");
	this.assertTrue(items[8] == "Nine");
	this.assertTrue(items[9] == "Ten");
	this.assertTrue(items.length == 10);

	var items = this.objects.collect()
	this.assertTrue(items[0].name == "One");
	this.assertTrue(items[1].name == "Two");
	this.assertTrue(items[2].name == "Three");
	this.assertTrue(items[3].name == "Four");
	this.assertTrue(items[4].name == "Five");
	this.assertTrue(items[5].name == "Six");
	this.assertTrue(items[6].name == "Seven");
	this.assertTrue(items[7].name == "Eight");
	this.assertTrue(items[8].name == "Nine");
	this.assertTrue(items[9].name == "Ten");
	this.assertTrue(items.length == 10);
};

ArrayTest.prototype.testDetect = function() {

	var result = this.objects.detect(function(_value, _index) {

		return _value.name == "Eight";
	});

	this.assertTrue(result.name == "Eight");
};

ArrayTest.prototype.testFindAll = function() {

	var items = this.objects.findAll(function(_value, _index) {

		return _value.id >= 6 && _value.id <= 10;
	});

	this.assertTrue(items[0].name == "Six");
	this.assertTrue(items[1].name == "Seven");
	this.assertTrue(items[2].name == "Eight");
	this.assertTrue(items[3].name == "Nine");
	this.assertTrue(items[4].name == "Ten");
};

ArrayTest.prototype.testGrep = function() {

	var items = this.objects.grep(/ne/, function(_value, _index) {

		return _value.id;
	});


	this.assertTrue(items[0] == "1");
	this.assertTrue(items[1] == "9");
};

ArrayTest.prototype.testInclude = function() {

	var match = this.objects.get(5);
	this.assertTrue(this.objects.include(match));

	var match = {name:"Eleven"};
	this.assertFalse(this.objects.include(match));
};

ArrayTest.prototype.testInject = function() {

	var counter = 0;
	var counter2 = 0;
	var memo = this.objects.inject("Zero ", function(_memo, _value, _index) {

		counter++;
		counter2 = _index;

		return _memo + _value.name + " ";
	});

	this.assertTrue(memo == "Zero One Two Three Four Five Six Seven Eight Nine Ten ");
	this.assertTrue(counter == 10);
	this.assertTrue(counter2 == 9);
};

ArrayTest.prototype.testInvoke = function() {

	this.objects.invoke("talk", "My name is ");
};

ArrayTest.prototype.testMax = function() {

	var result = this.objects.max(function(_value, _index, _value2) {

		if(_value.id < _value2.id) {

			return _value2;
		}
		return _value.id;
	});

	this.assertSame(this.objects.get(9), result);
};

ArrayTest.prototype.testMin = function() {

	var result = this.objects.min(function(_value, _index) {

		return _value.id;
	});

	this.assertSame(this.objects.get(0), result);
};

ArrayTest.prototype.testPartition = function() {

	var items = this.objects.partition(function(_value, _index) {

		if(_value.id >= 1 && _value.id <= 5) {

			return true;
		}

		return false;
	});

	var trues = items[0];
	var falses = items[1];

	this.assertTrue(trues.length == 5);
	this.assertTrue(falses.length == 5);

	this.assertTrue(trues[0].name == "One");
	this.assertTrue(trues[1].name == "Two");
	this.assertTrue(trues[2].name == "Three");
	this.assertTrue(trues[3].name == "Four");
	this.assertTrue(trues[4].name == "Five");

	this.assertTrue(falses[0].name == "Six");
	this.assertTrue(falses[1].name == "Seven");
	this.assertTrue(falses[2].name == "Eight");
	this.assertTrue(falses[3].name == "Nine");
	this.assertTrue(falses[4].name == "Ten");
};

ArrayTest.prototype.testPluck = function() {

	var items = this.objects.pluck("name");

	this.assertTrue(items[0] == "One");
	this.assertTrue(items[1] == "Two");
	this.assertTrue(items[2] == "Three");
	this.assertTrue(items[3] == "Four");
	this.assertTrue(items[4] == "Five");
	this.assertTrue(items[5] == "Six");
	this.assertTrue(items[6] == "Seven");
	this.assertTrue(items[7] == "Eight");
	this.assertTrue(items[8] == "Nine");
	this.assertTrue(items[9] == "Ten");
};

ArrayTest.prototype.testReject = function() {

	var items = this.objects.reject(function(_value, _index) {
	
		return _value.id < 9;
	});

	this.assertTrue(items[0].name == "Nine");
	this.assertTrue(items[1].name == "Ten");
};

ArrayTest.prototype.testSortBy = function() {

	var items = this.objects.toArray();
	this.assertTrue(items[0].id == 1);

	var items2 = this.objects.sortBy(function(_value, _index) {

		return -1 * _value.id;
	});
	this.assertTrue(items2[0].id == 10);
};

ArrayTest.prototype.testZip = function() {

	var list1 = [];
	var list2 = [];
	var list3 = [];

	list1.push(this.objects.get(0));
	list1.push(this.objects.get(1));
	list1.push(this.objects.get(2));

	list2.push(this.objects.get(3));
	list2.push(this.objects.get(4));
	list2.push(this.objects.get(5));

	list3.push(this.objects.get(6));
	list3.push(this.objects.get(7));
	list3.push(this.objects.get(8));
	
	this.assertTrue([[this.objects.get(0), this.objects.get(3), this.objects.get(6)],
						[this.objects.get(1), this.objects.get(4), this.objects.get(7)],
						[this.objects.get(2), this.objects.get(5), this.objects.get(8)]].equals(list1.zip(list2, list3)));
	
};

// querying tests

ArrayTest.prototype.testGet = function() {

	var testObject1 = this.objects.get(0);
	var testObject2 = this.objects.get(1);
	var testObject3 = this.objects.get(2);
	var testObject4 = this.objects.get(3);
	var testObject5 = this.objects.get(4);
	var testObject6 = this.objects.get(5);
	var testObject7 = this.objects.get(6);
	var testObject8 = this.objects.get(7);
	var testObject9 = this.objects.get(8);
	var testObject10 = this.objects.get(9);

	this.assertTrue(testObject1.equals(this.objects.get(0)));
	this.assertTrue(testObject2.equals(this.objects.get(1)));
	this.assertTrue(testObject3.equals(this.objects.get(2)));
	this.assertTrue(testObject4.equals(this.objects.get(3)));
	this.assertTrue(testObject5.equals(this.objects.get(4)));
	this.assertTrue(testObject6.equals(this.objects.get(5)));
	this.assertTrue(testObject7.equals(this.objects.get(6)));
	this.assertTrue(testObject8.equals(this.objects.get(7)));
	this.assertTrue(testObject9.equals(this.objects.get(8)));
	this.assertTrue(testObject10.equals(this.objects.get(9)));
};

ArrayTest.prototype.testIndexOf = function() {

	this.assertTrue(this.nums1.indexOf(5)>-1);
	this.assertTrue(this.nums1.indexOf(6)==-1);

	this.assertTrue(this.strings1.indexOf("five")>-1);
	this.assertTrue(this.strings1.indexOf("six")==-1);

	var _true = {};
	_true.name = "Five";
	this.assertTrue(this.objects.indexOf(_true)>-1);

	var _false = {};
	_false.name = "Eleven";
	this.assertTrue(this.objects.indexOf(_false)==-1);
	
	var match = this.objects.get(6);
	var index = this.objects.indexOf(match);
	this.assertTrue(index == 6)
	this.assertTrue(this.objects.indexOf(23422) == -1);	
};

ArrayTest.prototype.testLastIndexOf = function() {

	var match = this.objects.get(4);
	this.objects.add(match);
	var index = this.objects.lastIndexOf(match);
	this.assertTrue(index == 10)
	this.assertTrue(this.objects.lastIndexOf(23422) == -1);
};

ArrayTest.prototype.testContains = function() {

	this.assertFalse(this.objects.contains(null));
	this.objects.push(null);
	this.assertTrue(this.objects.contains(null));

	this.assertFalse(this.objects.contains(1000));
	this.objects.push(1000)
	this.assertTrue(this.objects.contains(1000));
};

ArrayTest.prototype.testContainsAll = function() {

	var newList = [];
	newList.push(this.objects.get(0));
	newList.push(this.objects.get(1));
	newList.push(this.objects.get(2));

	this.assertTrue(this.objects.containsAll(newList));

	newList.push(1000);

	this.assertFalse(this.objects.containsAll(newList));

	this.objects.push(1000);

	this.assertTrue(this.objects.containsAll(newList));
};

ArrayTest.prototype.testPeek = function() {

	var object = this.objects.get(9);
	var object2 = this.objects.peek();

	this.assertTrue(object.equals(object2));
	this.assertTrue(this.objects.size() == 10);
};

ArrayTest.prototype.testSearch = function() {

	var index = 9;
	var object = this.objects.get(index);

	var index2 = this.objects.search(object);

	this.assertTrue(index2 == 1);
};

ArrayTest.prototype.testSize = function() {

	this.assertTrue(this.objects.size() == 10);
	this.assertTrue([].size() == 0);
};

ArrayTest.prototype.testIsEmpty = function() {

	var newList = [];

	this.assertTrue(newList.isEmpty());

	newList.push(this.objects.get(0));
	newList.push(this.objects.get(1));
	newList.push(this.objects.get(2));

	this.assertFalse(newList.isEmpty());
};

ArrayTest.prototype.testSubList = function() {

	var testObject1 = this.objects.get(0);
	var testObject2 = this.objects.get(1);
	var testObject3 = this.objects.get(2);
	var testObject4 = this.objects.get(3);
	var testObject5 = this.objects.get(4);
	var testObject6 = this.objects.get(5);
	var testObject7 = this.objects.get(6);
	var testObject8 = this.objects.get(7);
	var testObject9 = this.objects.get(8);
	var testObject10 = this.objects.get(9);

	var newList = this.objects.subList(3, 8);

	this.assertTrue(newList.size() == 6);

	this.assertFalse(newList.indexOf(testObject1) > -1);
	this.assertFalse(newList.indexOf(testObject2) > -1);
	this.assertFalse(newList.indexOf(testObject3) > -1);

	this.assertTrue(newList.indexOf(testObject4) > -1);
	this.assertTrue(newList.indexOf(testObject5) > -1);
	this.assertTrue(newList.indexOf(testObject6) > -1);
	this.assertTrue(newList.indexOf(testObject8) > -1);
	this.assertTrue(newList.indexOf(testObject8) > -1);
	this.assertTrue(newList.indexOf(testObject9) > -1);

	this.assertFalse(newList.indexOf(testObject10) > -1);
};

// mutating methods

ArrayTest.prototype.testSet = function() {

	var testObject1 = this.objects.get(0);
	var testObject2 = this.objects.get(1);
	var testObject3 = this.objects.get(2);
	var testObject4 = this.objects.get(3);
	var testObject5 = this.objects.get(4);
	var testObject6 = this.objects.get(5);
	var testObject7 = this.objects.get(6);
	var testObject8 = this.objects.get(7);
	var testObject9 = this.objects.get(8);
	var testObject10 = this.objects.get(9);

	this.objects.set(0, testObject10);
	this.objects.set(1, testObject9);
	this.objects.set(2, testObject8);
	this.objects.set(3, testObject7);
	this.objects.set(4, testObject6);
	this.objects.set(5, testObject5);
	this.objects.set(6, testObject4);
	this.objects.set(7, testObject3);
	this.objects.set(8, testObject2);
	this.objects.set(9, testObject1);

	this.assertTrue(testObject1.equals(this.objects.get(9)));
	this.assertTrue(testObject2.equals(this.objects.get(8)));
	this.assertTrue(testObject3.equals(this.objects.get(7)));
	this.assertTrue(testObject4.equals(this.objects.get(6)));
	this.assertTrue(testObject5.equals(this.objects.get(5)));
	this.assertTrue(testObject6.equals(this.objects.get(4)));
	this.assertTrue(testObject7.equals(this.objects.get(3)));
	this.assertTrue(testObject8.equals(this.objects.get(2)));
	this.assertTrue(testObject9.equals(this.objects.get(1)));
	this.assertTrue(testObject10.equals(this.objects.get(0)));
};

ArrayTest.prototype.testAddAt = function() {

	var _object = "Adding at index 5";
	this.objects.addAt(5, _object);
	this.assertTrue(this.objects.get(5).equals(_object));

	this.objects.addAt(0, null);
	this.assertTrue(this.objects.get(0) == null);
};

ArrayTest.prototype.testAddAllAt = function() {

	var newCollection = [];
	newCollection.add(1);
	newCollection.add(2);
	newCollection.add(3);
	newCollection.add(4);
	newCollection.add(5);

	var beforeSize = this.objects.size();

	this.assertTrue(this.objects.addAllAt(3, newCollection));

	this.assertTrue(this.objects.size() == (beforeSize + newCollection.size()));
	this.assertTrue(this.objects.get(3) == 1);
	this.assertTrue(this.objects.get(4) == 2);
	this.assertTrue(this.objects.get(5) == 3);
	this.assertTrue(this.objects.get(6) == 4);
	this.assertTrue(this.objects.get(7) == 5);
};

ArrayTest.prototype.testAdd = function() {

	this.assertTrue(this.objects.add("Adding Item"));
	this.assertTrue(this.objects.add(null));
};

ArrayTest.prototype.testAddAll = function() {

	this.assertTrue(this.objects.size() == 10);

	var newList = [];
	newList.add(5);
	newList.add(4);
	newList.add(3);

	this.assertTrue(this.objects.addAll(newList) == true);
	this.assertTrue(this.objects.size() == 13);
};

ArrayTest.prototype.testRemoveAt = function() {

	var testObject = this.objects.get(4);

	this.assertTrue(this.objects.get(4).equals(testObject));
	this.assertTrue(this.objects.removeAt(4));
	this.assertTrue(this.objects.size() == 9);
	this.assertFalse(this.objects.get(4).equals(testObject));

	this.objects.add(null);

	this.assertTrue(this.objects.removeAt(this.objects.indexOf(null)));

	this.assertFalse(this.objects.removeAt(100));
};

ArrayTest.prototype.testRemove = function() {

	var testObject = this.objects.get(4);

	this.assertTrue(this.objects.get(4).equals(testObject));
	this.assertTrue(this.objects.remove(testObject));
	this.assertTrue(this.objects.size() == 9);
	this.assertFalse(this.objects.get(4).equals(testObject));
	this.assertFalse(this.objects.remove("not found"));
	this.assertFalse(this.objects.remove(null));
};

ArrayTest.prototype.testRemoveAll = function() {

	var newList = [];

	newList.add(1000);
	this.assertFalse(this.objects.removeAll(newList));
	this.assertTrue(this.objects.size() == 10);

	newList.clear();

	newList.add(this.objects.get(5));
	newList.add(this.objects.get(9));
	newList.add(this.objects.get(2));
	this.assertTrue(this.objects.removeAll(newList));
	this.assertTrue(this.objects.size() == 7);
};

ArrayTest.prototype.testRetainAllNoFind = function() {

	var newList = [];
	
	newList.add(this.objects.get(5));

	this.assertTrue(this.objects.retainAll(newList));
	this.assertTrue(this.objects.size() == 1);
};

ArrayTest.prototype.testRetainAllFind = function() {

	var newList = [];

	newList.add(this.objects.get(5));
	newList.add(this.objects.get(9));
	newList.add(this.objects.get(2));
	this.assertTrue(this.objects.retainAll(newList));
	this.assertTrue(this.objects.size() == 3);
};

ArrayTest.prototype.testClear = function() {

	this.assertTrue(this.objects.size() == 10);
	this.objects.clear();
	this.assertTrue(this.objects.size() == 0);
};

// sorting tests

ArrayTest.prototype.testStringAscCompare = function() {

	var strings = ["Rick", "Mathew", "Todd", "Becky", "Annie"];

	strings.sort(strings.getStringComparator());

	this.assertTrue("Annie" == strings[0]);
	this.assertTrue("Todd" == strings[strings.length-1]);
};

ArrayTest.prototype.testStringDescCompare = function() {

	var strings = ["Rick", "Mathew", "Todd", "Becky", "Annie"];

	strings.sort(strings.getStringComparator(true));

	this.assertTrue("Todd" == strings[0]);
	this.assertTrue("Annie" == strings[strings.length-1]);
};

ArrayTest.prototype.testNumberAscCompare = function() {

	var numbers = [2, 4, 3, 5, 1];

	numbers.sort(numbers.getNumberComparator());

	this.assertTrue(numbers[0] == 1);
	this.assertTrue(numbers[numbers.length-1] == 5);

	this.assertFalse(numbers[0] == 5);
	this.assertFalse(numbers[numbers.length-1] == 1);
};

ArrayTest.prototype.testNumberDescCompare = function() {

	var numbers = [2, 4, 3, 5, 1];

	numbers.sort(numbers.getNumberComparator(true));

	this.assertTrue(numbers[0] == 5);
	this.assertTrue(numbers[numbers.length-1] == 1);

	this.assertFalse(numbers[0] == 1);
	this.assertFalse(numbers[numbers.length-1] == 5);
};

ArrayTest.prototype.testDateAscCompare = function() {

	var dates = ["12/23/06", "03/28/06", "06/30/06", "09/16/06", "01/01/06"];

	dates.sort(dates.getDateComparator());

	this.assertTrue(dates[0] == "01/01/06");
	this.assertTrue(dates[dates.length-1] == "12/23/06");

	this.assertFalse(dates[0] == "12/23/06");
	this.assertFalse(dates[dates.length-1] == "01/01/06");
};

ArrayTest.prototype.testDateDescCompare = function() {

	var dates = ["12/23/06", "03/28/06", "06/30/06", "09/16/06", "01/01/06"];

	dates.sort(dates.getDateComparator(true));

	this.assertTrue(dates[0] == "12/23/06");
	this.assertTrue(dates[dates.length-1] == "01/01/06");

	this.assertFalse(dates[0] == "01/01/06");
	this.assertFalse(dates[dates.length-1] == "12/23/06");
};

ArrayTest.prototype.testCurrencyAscCompare = function() {

	var amounts = ["$2.29", "$5.19", "$4.87", "$1.32", "$3.65"];

	amounts.sort(amounts.getCurrencyComparator());

	this.assertTrue(amounts[0] == "$1.32");
	this.assertTrue(amounts[amounts.length-1] == "$5.19");

	this.assertFalse(amounts[0] == "$5.19");
	this.assertFalse(amounts[amounts.length-1] == "$1.32");
};

ArrayTest.prototype.testCurrencyDescCompare = function() {

	var amounts = ["$2.29", "$5.19", "$4.87", "$1.32", "$3.65"];

	amounts.sort(amounts.getCurrencyComparator(true));

	this.assertTrue(amounts[0] == "$5.19");
	this.assertTrue(amounts[amounts.length-1] == "$1.32");

	this.assertFalse(amounts[0] == "$1.32");
	this.assertFalse(amounts[amounts.length-1] == "$5.19");
};
