var TestCase = require("bn-unit").TestCase;
var Closure = require("bn-lang").Closure;

// setup test case
var ClosureTest = function(){this.init.apply(this, arguments);};
exports.ClosureTest = ClosureTest;

ClosureTest.prototype = new TestCase();
ClosureTest.prototype.constructor = ClosureTest;
ClosureTest.parentclass = TestCase.prototype;
ClosureTest.prototype.init = function() {};
ClosureTest.prototype.setUp = function() {

	ClosureTest.parentclass.setUp.apply(this, []);
};
ClosureTest.prototype.tearDown = function() {

	ClosureTest.parentclass.tearDown.apply(this, []);
};
ClosureTest.getName = function() {

	return "Closure";
};

// add tests
ClosureTest.prototype.testClosure = function() {

	var _object = {};
	_object.prop1 = "One";
	_object.prop2 = "Two";
	_object.prop3 = "Three";

	var me = this;
	var closure = new Closure().bind(function(_number) {

		me.assertTrue(this.prop1.equals("One"));
		me.assertTrue(this.prop2.equals("Two"));
		me.assertTrue(this.prop3.equals("Three"));

		return _number;
	}, _object, [1000]);

	this.assertTrue(closure().equals(1000));
};
