var TestCase = require("bn-unit").TestCase;

// setup test case
var DateTest = function(){this.init.apply(this, arguments);};
exports.DateTest = DateTest;

DateTest.prototype = new TestCase();
DateTest.prototype.constructor = DateTest;
DateTest.parentclass = TestCase.prototype;
DateTest.prototype.init = function() {};
DateTest.prototype.setUp = function() {

	DateTest.parentclass.setUp.apply(this, []);
	this.date = new Date(2007, 6, 15);
};
DateTest.prototype.tearDown = function() {

	DateTest.parentclass.tearDown.apply(this, []);
	this.date = null;
};
DateTest.getName = function() {

	return "Date";
};

// add tests
DateTest.prototype.testGetDifference = function() {

	var _date = new Date(2007, 6, 16);

	this.assertEquals(_date.getDifference(this.date), Date.ONE_DAY_MILLISECONDS);
};

DateTest.prototype.testIsBefore = function() {

	var _date = new Date();

	this.assertTrue(this.date.isBefore(_date));
};

DateTest.prototype.testIsAfter = function() {

	var _date = new Date();

	this.assertTrue(_date.isAfter(this.date));
};

DateTest.prototype.testGetWeekInYear = function() {

	this.assertEquals(this.date.getWeekInYear(), 29);
};

DateTest.prototype.testGetWeekInMonth = function() {

	this.assertEquals(this.date.getWeekInMonth(), 3);
};

DateTest.prototype.testGetDayInYear = function() {

	this.assertEquals(this.date.getDayInYear(), 195);
};

DateTest.prototype.testEquals = function() {

	this.assertEquals(this.date, this.date);
	this.assertTrue(this.date.equals(new Date(2007, 6, 15)));
};
