var TestCase = require("bn-unit").TestCase;
var HashSet = require("bn-lang").HashSet;

// setup test case
var HashSetTest = function(){this.init.apply(this, arguments);};
exports.HashSetTest = HashSetTest;

HashSetTest.prototype = new TestCase();
HashSetTest.prototype.constructor = HashSetTest;
HashSetTest.parentclass = TestCase.prototype;
HashSetTest.prototype.init = function() {}
HashSetTest.prototype.setUp = function(){

	HashSetTest.parentclass.setUp.apply(this, []);

	this.set = new HashSet();

	var equalsFunction = function(_object) {

		if(this === _object) {

			return true;
		}

		return this.name == _object.name;
	};

	var talkFunction = function(_word) {

		return _word +" "+this.name;
	};

	this.set.add({name:"One",id:1,toString:function(){return "One: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.set.add({name:"Two",id:2,toString:function(){return "Two: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.set.add({name:"Three",id:3,toString:function(){return "Three: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.set.add({name:"Four",id:4,toString:function(){return "Four: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.set.add({name:"Five",id:5,toString:function(){return "Five: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.set.add({name:"Six",id:6,toString:function(){return "Six: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.set.add({name:"Seven",id:7,toString:function(){return "Seven: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.set.add({name:"Eight",id:8,toString:function(){return "Eight: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.set.add({name:"Nine",id:9,toString:function(){return "Nine: "+this.id;},equals:equalsFunction,talk:talkFunction});
	this.set.add({name:"Ten",id:10,toString:function(){return "Ten: "+this.id;},equals:equalsFunction,talk:talkFunction});	
};
HashSetTest.prototype.tearDown = function() {

	HashSetTest.parentclass.tearDown.apply(this, []);

	this.set = null;
};
HashSetTest.getName = function() {

	return "HashSet";
};

// add tests

HashSetTest.prototype.testAdd = function() {

	this.assertTrue(this.set.size() == 10);

	this.assertTrue(this.set.add(1));
	this.assertTrue(this.set.size() == 11);

	this.assertFalse(this.set.add(1));
	this.assertTrue(this.set.size() == 11);
};

HashSetTest.prototype.testClear = function() {

	this.assertTrue(this.set.size() == 10);
	this.set.clear();
	this.assertTrue(this.set.size() == 0);
};

HashSetTest.prototype.testContains = function() {

	this.assertTrue(this.set.add(1));

	this.assertTrue(this.set.contains(1));

	this.assertFalse(this.set.contains("Eleven"));
};

HashSetTest.prototype.testIsEmpty = function() {

	this.assertFalse(this.set.isEmpty());
	this.set.clear();
	this.assertTrue(this.set.isEmpty());
};

HashSetTest.prototype.testRemove = function() {

	this.assertTrue(this.set.add(1));
	this.assertTrue(this.set.add(2));
	this.assertTrue(this.set.add(3));
	this.assertTrue(this.set.size() == 13);

	this.assertTrue(this.set.remove(1));
	this.assertTrue(this.set.remove(2));
	this.assertTrue(this.set.remove(3));
	this.assertTrue(this.set.size() == 10);
};

HashSetTest.prototype.testSize = function() {

	this.assertTrue(this.set.size() == 10);
	this.set.clear();
	this.assertTrue(this.set.size() == 0);
};
