var TestCase = require("bn-unit").TestCase;

// setup test case
var NumberTest = function(){this.init.apply(this, arguments);};
exports.NumberTest = NumberTest;

NumberTest.prototype = new TestCase();
NumberTest.prototype.constructor = NumberTest;
NumberTest.parentclass = TestCase.prototype;
NumberTest.prototype.init = function() {};
NumberTest.prototype.setUp = function() {

	NumberTest.parentclass.setUp.apply(this, []);
};
NumberTest.prototype.tearDown = function() {

	NumberTest.parentclass.tearDown.apply(this, []);
};
NumberTest.getName = function() {

	return "Number";
};

// add tests
NumberTest.prototype.testTime = function() {

	var _times = 10;
	var _counter = 0;
	_times.times(function(_number) {

		_counter++;
	});
	this.assertTrue(_counter == 10);
};

NumberTest.prototype.testUpto = function() {

	var _upto = 1;
	var _counter = 0;
	_upto.upto(10, function(_number) {

		_counter++;
	});
	this.assertTrue(_counter == 10);
};

NumberTest.prototype.testDownto = function() {

	var _downto = 1;
	var _counter = 0;
	_downto.upto(10, function(_number) {

		_counter++;
	});
	this.assertTrue(_counter == 10);
};

NumberTest.prototype.testTowards = function() {

	var _towards = 0;
	var _counter = 0;
	_towards.towards(-10, function(_number) {

		_counter++;
	});
	this.assertTrue(_counter == 11);
};

NumberTest.prototype.testSucc = function() {

	var _number = 0;
	this.assertTrue(_number.succ() == 1);
};

NumberTest.prototype.testPred = function() {

	var _number = 1;
	this.assertTrue(_number.pred() == 0);
};

NumberTest.prototype.testToArray = function() {

	var test = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9];
	var start = 0;
	var result = start.toArray(9);

	this.assertTrue(result.length == test.length);
};

NumberTest.prototype.testDotEqualsTrue = function() {

	var test1 = 123456789;
	var test2 = 123456789;

	this.assertTrue(test1.equals(test2));
	this.assertTrue(test1.equals(123456789));
	this.assertTrue(Number(123456789).equals(123456789));
};

NumberTest.prototype.testDotEqualsFalse = function() {

	var test1 = 123456789;
	var test2 = 123456780;

	this.assertFalse(test1.equals(test2));
	this.assertFalse(test1.equals(123456780));
	this.assertFalse(Number(123456789).equals(123456780));
};
