var TestSuite = require("bn-unit").TestSuite;

var BooleanTest	= require("./BooleanTest").BooleanTest;
var NumberTest	= require("./NumberTest").NumberTest;
var ArrayTest	= require("./ArrayTest").ArrayTest;
var StringTest	= require("./StringTest").StringTest;
var DateTest	= require("./DateTest").DateTest;
var RegExpTest	= require("./RegExpTest").RegExpTest;
var MathTest	= require("./MathTest").MathTest;

var EnumerableTest	= require("./EnumerableTest").EnumerableTest;
var ClosureTest		= require("./ClosureTest").ClosureTest;
var AsyncTaskTest	= require("./AsyncTaskTest").AsyncTaskTest;
var HashTest		= require("./HashTest").HashTest;
var HashSetTest		= require("./HashSetTest").HashSetTest;

var LangTestSuite = function(){this.init.apply(this, arguments);};
exports.LangTestSuite = LangTestSuite;

LangTestSuite.prototype.init = function(){};
LangTestSuite.suite = function() {

	var _suite = new TestSuite("Tests for Lang");

	_suite.addTest(new TestSuite(BooleanTest.getName(), BooleanTest));
	_suite.addTest(new TestSuite(NumberTest.getName(), NumberTest));
	_suite.addTest(new TestSuite(ArrayTest.getName(), ArrayTest));
	_suite.addTest(new TestSuite(StringTest.getName(), StringTest));
	_suite.addTest(new TestSuite(DateTest.getName(), DateTest));
	_suite.addTest(new TestSuite(RegExpTest.getName(), RegExpTest));
	_suite.addTest(new TestSuite(MathTest.getName(), MathTest));

	_suite.addTest(new TestSuite(EnumerableTest.getName(), EnumerableTest));
	_suite.addTest(new TestSuite(ClosureTest.getName(), ClosureTest));
	_suite.addTest(new TestSuite(AsyncTaskTest.getName(), AsyncTaskTest));
	_suite.addTest(new TestSuite(HashTest.getName(), HashTest));
	_suite.addTest(new TestSuite(HashSetTest.getName(), HashSetTest));

	return _suite;
};