/**
* @class Assert
*/
var Assert = function(){this.init.apply(this, arguments);};
exports.Assert = Assert;

/** @ignore */
Assert.prototype.init = function(){};

Assert.assertTrue = function(_condition, _message) {

	if(!_condition) {

		if(!_message){ _message = "Assert True failed"; }
		this.failTrue(_message);
	}
};

Assert.assertFalse = function(_condition, _message) {

	if(!_message){ _message = "Assert False failed"; }
	this.assertTrue(!_condition, _message);
};

Assert.assertEquals = function(_expected, _actual, _message) {

	if(_expected == null && _actual == null) {

		return;
	}

	if(_expected != null && _expected == _actual) {
		return;
	}

	this.failNotEquals(_expected, _actual, _message);
};

Assert.assertNull = function(_object, _message) {

	this.assertTrue((_object == null), _message);
};

Assert.assertNotNull = function(_object, _message) {

	this.assertTrue((_object != null), _message);
};

Assert.assertSame = function(_expected, _actual, _message) {

	if(_expected === _actual) {

		return;
	}
	this.failNotSame(_expected, _actual, _message);
};

Assert.assertNotSame = function(_expected, _actual, _message) {

	if(_expected === _actual) {

		this.failSame(_message);
	}
};

Assert.fail = function(_message) {

	throw new AssertionFailedError(_message);
};

Assert.failTrue = function(_message) {

	this.fail(_message);
};

Assert.failNotEquals = function(_expected, _actual, _message) {

	var formatted = "";
	if(_message) {

		formatted = _message + " ";
	}
	this.fail(formatted + "expected:< " + _expected + " > but was:< " + _actual + " >");
};

Assert.failSame = function(_message) {

	var formatted = "";
	if(_message) {

		formatted = _message + " ";
	}
	this.fail(formatted + "expected not same");
};

Assert.failNotSame = function(_expected, _actual, _message) {

	var formatted = "";
	if(_message) {

		formatted = _message + " ";
	}
	this.fail(formatted + "expected same:< " + _expected + " > was not:< " + _actual + " >");
};
