/**
* @class ResultPrinterText
* @constructor
* @param {Object} _output
*/
var ResultPrinterText = function(){this.init.apply(this, arguments);};
exports.ResultPrinterText = ResultPrinterText;

ResultPrinterText.prototype = {
	/** @ignore */
	init : function(_output) {

		this.output = _output;
	},
	print : function(_test, _result, _runTime) {

		var _text = "";

		_text += "[unit] Running ";
		_text += _test.getName();

		_text += "\n[unit] Tests run: ";
		_text += _result.runCount();

		_text += ", Failures: ";
		_text += _result.failureCount();

		_text += ", Errors: ";
		_text += _result.errorCount();

		_text += ", Time elapsed: ";
		_text += _runTime;
		_text += " millisec";

		if(!_result.wasSuccessful()) {

			_text += "\n[unit] Test ";
			_text += _test.getName();
			_text += " FAILED";

			if(_result.failureCount() > 0) {

				_text += "\n\n\t\tFailures";
				
				var _failures = _result.getFailures();
				for (var i=0;i<_failures.length;i++) {

					var _failure = _failures[i];

					_text += "\n\t\t";
					_text += _failure.getTestCase();
					_text += ": ";
					_text += _failure.getTest();
					_text += " - ";
					_text += _failure.getException().message;
				}
			}

			if(_result.errorCount() > 0) {

				_text += "\n\n\t\tErrors";

				var _errors = _result.getErrors();
				for (var i=0;i<_errors.length;i++) {

					var _error = _errors[i];

					_text += "\n\t\t";
					_text += _error.getTestCase();
					_text += ": ";
					_text += _error.getTest();
					_text += " - ";
					_text += _error.getException().message;
				}
			}
		}

		_text += "\n";

		this.output(_text);
	},
	startTest : function(_test) {},
	endTest : function(_test) {},
	addSuccess : function(_test) {},
	addFailure : function(_test, _failure) {},
	addError : function(_test, _error) {}
};
