/**
* @class TestCase
* @constructor
*/
var TestCase = function(){this.init.apply(this, arguments);};
exports.TestCase = TestCase;

TestCase.prototype = {
	/** @ignore */
	init : function() {

		this.name = null;
	},
	setUp : function(){},
	tearDown : function(){},
	getName : function() {

		return this.name;
	},
	setName : function(_name) {

		this.name = _name;
	},
	countTestCases : function() {

		return 1;
	},
	run : function(_result) {

		if(_result) {

			_result.run(this);
			
		} else {

			var result = new TestResult();
			result.run(this);
		}
	},
	runBare : function() {

		this.setUp();
		try {

			this.runTest();

		} finally {

			this.tearDown();
		}
	},
	runTest : function() {

		this.assertNotNull(this.name, "TestCase.name cannot be null");

		var runMethod = this[this.name];

		if(runMethod) {

			runMethod.apply(this, []);

		} else {

			this.fail("Method \""+this.name+"\" not found");
		}
	},
	toString : function() {

		return this.name;
	},
	assertTrue : Assert.assertTrue,
	assertFalse : Assert.assertFalse,
	assertEquals : Assert.assertEquals,
	assertNull : Assert.assertNull,
	assertNotNull : Assert.assertNotNull,
	assertSame : Assert.assertSame,
	assertNotSame : Assert.assertNotSame,
	fail : Assert.fail,
	failTrue : Assert.failTrue,
	failNotEquals : Assert.failNotEquals,
	failSame : Assert.failSame,
	failNotSame : Assert.failNotSame
};
