/**
* @class TestRunner
* @constructor
* @param {ResultPrinter} _resultPrinter
*/
var TestRunner = function(){this.init.apply(this, arguments);};
exports.TestRunner = TestRunner;

TestRunner.prototype = {
	/** @ignore */
	init : function(_resultPrinter) {

		this.resultPrinter = _resultPrinter;
	},
	getTest : function(_testSuiteClass) {

		return _testSuiteClass.suite();
	},
	runTest : function(_test) {

		var _suite = new TestSuite("Tests for "+_test.getName(), _test);

		this.run(_suite);
	},
	runSuite : function(_testSuite) {

		var _suite = this.getTest(_testSuite);

		this.run(_suite);
	},
	run : function(_test) {

		var result = new TestResult();

		result.addListener(this.resultPrinter);

		var startTime = new Date().getTime();

		_test.run(result);

		var endTime = new Date().getTime();

		var runTime = endTime - startTime;

		this.resultPrinter.print(_test, result, runTime);

		return result;
	}
};
